Index: uspace/drv/bus/usb/ohci/pci.c
===================================================================
--- uspace/drv/bus/usb/ohci/pci.c	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ uspace/drv/bus/usb/ohci/pci.c	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -70,19 +70,19 @@
 	if (!parent_sess)
 		return ENOMEM;
-	
+
 	hw_resource_list_t hw_resources;
 	int rc = hw_res_get_resource_list(parent_sess, &hw_resources);
+	async_hangup(parent_sess);
 	if (rc != EOK) {
-		async_hangup(parent_sess);
 		return rc;
 	}
-	
+
 	uintptr_t mem_address = 0;
 	size_t mem_size = 0;
 	bool mem_found = false;
-	
+
 	int irq = 0;
 	bool irq_found = false;
-	
+
 	size_t i;
 	for (i = 0; i < hw_resources.count; i++) {
@@ -107,15 +107,13 @@
 		}
 	}
-	
+	free(hw_resources.resources);
+
 	if (mem_found && irq_found) {
 		*mem_reg_address = mem_address;
 		*mem_reg_size = mem_size;
 		*irq_no = irq;
-		rc = EOK;
-	} else
-		rc = ENOENT;
-	
-	async_hangup(parent_sess);
-	return rc;
+		return EOK;
+	}
+	return ENOENT;
 }
 
Index: uspace/drv/bus/usb/ohci/root_hub.c
===================================================================
--- uspace/drv/bus/usb/ohci/root_hub.c	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ uspace/drv/bus/usb/ohci/root_hub.c	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -121,7 +121,6 @@
 	assert(request);
 
-	memcpy(request->data_buffer, &mask, size);
 	request->transfered_size = size;
-	usb_transfer_batch_finish_error(request, EOK);
+	usb_transfer_batch_finish_error(request, &mask, size, EOK);
 }
 
@@ -206,5 +205,5 @@
 		usb_log_debug("Root hub got CONTROL packet\n");
 		const int ret = control_request(instance, request);
-		usb_transfer_batch_finish_error(request, ret);
+		usb_transfer_batch_finish_error(request, NULL, 0, ret);
 		break;
 	case USB_TRANSFER_INTERRUPT:
@@ -215,5 +214,5 @@
 			assert(instance->unfinished_interrupt_transfer == NULL);
 			instance->unfinished_interrupt_transfer = request;
-			break;
+			return;
 		}
 		usb_log_debug("Processing changes...\n");
@@ -223,6 +222,7 @@
 	default:
 		usb_log_error("Root hub got unsupported request.\n");
-		usb_transfer_batch_finish_error(request, EINVAL);
-	}
+		usb_transfer_batch_finish_error(request, NULL, 0, EINVAL);
+	}
+	usb_transfer_batch_dispose(request);
 }
 /*----------------------------------------------------------------------------*/
@@ -244,4 +244,5 @@
 	interrupt_request(instance->unfinished_interrupt_transfer,
 	    mask, instance->interrupt_mask_size);
+	usb_transfer_batch_dispose(instance->unfinished_interrupt_transfer);
 
 	instance->unfinished_interrupt_transfer = NULL;
@@ -389,6 +390,6 @@
 		const uint32_t data = instance->registers->rh_status &
 		    (RHS_LPS_FLAG | RHS_LPSC_FLAG | RHS_OCI_FLAG | RHS_OCIC_FLAG);
-		memcpy(request->data_buffer, &data, 4);
-		TRANSFER_OK(4);
+		memcpy(request->buffer, &data, sizeof(data));
+		TRANSFER_OK(sizeof(data));
 	}
 
@@ -402,6 +403,6 @@
 		const uint32_t data =
 		    instance->registers->rh_port_status[port - 1];
-		memcpy(request->data_buffer, &data, 4);
-		TRANSFER_OK(4);
+		memcpy(request->buffer, &data, sizeof(data));
+		TRANSFER_OK(sizeof(data));
 	}
 
@@ -483,5 +484,5 @@
 	}
 
-	memcpy(request->data_buffer, descriptor, size);
+	memcpy(request->buffer, descriptor, size);
 	TRANSFER_OK(size);
 }
@@ -713,5 +714,5 @@
 		if (request->buffer_size != 1)
 			return EINVAL;
-		request->data_buffer[0] = 1;
+		request->buffer[0] = 1;
 		TRANSFER_OK(1);
 
Index: uspace/drv/bus/usb/ohci/root_hub.h
===================================================================
--- uspace/drv/bus/usb/ohci/root_hub.h	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ uspace/drv/bus/usb/ohci/root_hub.h	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -37,7 +37,7 @@
 #include <usb/usb.h>
 #include <usb/dev/driver.h>
+#include <usb/host/usb_transfer_batch.h>
 
 #include "ohci_regs.h"
-#include "batch.h"
 
 #define HUB_DESCRIPTOR_MAX_SIZE (7 + 2 + 2)
@@ -66,5 +66,4 @@
 	/** size of hub descriptor */
 	size_t hub_descriptor_size;
-
 } rh_t;
 
Index: uspace/drv/bus/usb/ohci/utils/malloc32.h
===================================================================
--- uspace/drv/bus/usb/ohci/utils/malloc32.h	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ uspace/drv/bus/usb/ohci/utils/malloc32.h	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -46,5 +46,5 @@
  * @return Physical address if exists, NULL otherwise.
  */
-static inline uintptr_t addr_to_phys(void *addr)
+static inline uintptr_t addr_to_phys(const void *addr)
 {
 	uintptr_t result;
Index: uspace/drv/bus/usb/uhci/Makefile
===================================================================
--- uspace/drv/bus/usb/uhci/Makefile	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ uspace/drv/bus/usb/uhci/Makefile	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -42,13 +42,12 @@
 
 SOURCES = \
-	iface.c \
+	hc.c \
 	main.c \
+	pci.c \
+	root_hub.c \
 	transfer_list.c \
 	uhci.c \
-	hc.c \
-	root_hub.c \
-	hw_struct/transfer_descriptor.c \
-	pci.c \
-	batch.c
+	uhci_batch.c \
+	hw_struct/transfer_descriptor.c
 
 include $(USPACE_PREFIX)/Makefile.common
Index: uspace/drv/bus/usb/uhci/hc.c
===================================================================
--- uspace/drv/bus/usb/uhci/hc.c	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ uspace/drv/bus/usb/uhci/hc.c	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -41,4 +41,5 @@
 
 #include "hc.h"
+#include "uhci_batch.h"
 
 #define UHCI_INTR_ALLOW_INTERRUPTS \
@@ -46,4 +47,5 @@
 #define UHCI_STATUS_USED_INTERRUPTS \
     (UHCI_STATUS_INTERRUPT | UHCI_STATUS_ERROR_INTERRUPT)
+
 
 static const irq_cmd_t uhci_irq_commands[] =
@@ -57,7 +59,8 @@
 };
 
+static void hc_init_hw(const hc_t *instance);
+static int hc_init_mem_structures(hc_t *instance);
 static int hc_init_transfer_lists(hc_t *instance);
-static int hc_init_mem_structures(hc_t *instance);
-static void hc_init_hw(hc_t *instance);
+static int hc_schedule(hcd_t *hcd, usb_transfer_batch_t *batch);
 
 static int hc_interrupt_emulator(void *arg);
@@ -95,4 +98,61 @@
 	cmds[3].addr = (void*)&registers->usbsts;
 	return EOK;
+}
+/*----------------------------------------------------------------------------*/
+/** Take action based on the interrupt cause.
+ *
+ * @param[in] instance UHCI structure to use.
+ * @param[in] status Value of the status register at the time of interrupt.
+ *
+ * Interrupt might indicate:
+ * - transaction completed, either by triggering IOC, SPD, or an error
+ * - some kind of device error
+ * - resume from suspend state (not implemented)
+ */
+void hc_interrupt(hc_t *instance, uint16_t status)
+{
+	assert(instance);
+	/* Lower 2 bits are transaction error and transaction complete */
+	if (status & (UHCI_STATUS_INTERRUPT | UHCI_STATUS_ERROR_INTERRUPT)) {
+		LIST_INITIALIZE(done);
+		transfer_list_remove_finished(
+		    &instance->transfers_interrupt, &done);
+		transfer_list_remove_finished(
+		    &instance->transfers_control_slow, &done);
+		transfer_list_remove_finished(
+		    &instance->transfers_control_full, &done);
+		transfer_list_remove_finished(
+		    &instance->transfers_bulk_full, &done);
+
+		while (!list_empty(&done)) {
+			link_t *item = list_first(&done);
+			list_remove(item);
+			uhci_transfer_batch_t *batch =
+			    uhci_transfer_batch_from_link(item);
+			uhci_transfer_batch_call_dispose(batch);
+		}
+	}
+	/* Resume interrupts are not supported */
+	if (status & UHCI_STATUS_RESUME) {
+		usb_log_error("Resume interrupt!\n");
+	}
+
+	/* Bits 4 and 5 indicate hc error */
+	if (status & (UHCI_STATUS_PROCESS_ERROR | UHCI_STATUS_SYSTEM_ERROR)) {
+		usb_log_error("UHCI hardware failure!.\n");
+		++instance->hw_failures;
+		transfer_list_abort_all(&instance->transfers_interrupt);
+		transfer_list_abort_all(&instance->transfers_control_slow);
+		transfer_list_abort_all(&instance->transfers_control_full);
+		transfer_list_abort_all(&instance->transfers_bulk_full);
+
+		if (instance->hw_failures < UHCI_ALLOWED_HW_FAIL) {
+			/* reinitialize hw, this triggers virtual disconnect*/
+			hc_init_hw(instance);
+		} else {
+			usb_log_fatal("Too many UHCI hardware failures!.\n");
+			hc_fini(instance);
+		}
+	}
 }
 /*----------------------------------------------------------------------------*/
@@ -132,8 +192,23 @@
 	    "Device registers at %p (%zuB) accessible.\n", io, reg_size);
 
+	ret = hcd_init(&instance->generic, BANDWIDTH_AVAILABLE_USB11,
+	    bandwidth_count_usb11);
+	CHECK_RET_RETURN(ret, "Failed to initialize HCD generic driver: %s.\n",
+	    str_error(ret));
+
+	instance->generic.private_data = instance;
+	instance->generic.schedule = hc_schedule;
+	instance->generic.ep_add_hook = NULL;
+
+#undef CHECK_RET_DEST_FUN_RETURN
+
 	ret = hc_init_mem_structures(instance);
-	CHECK_RET_RETURN(ret,
-	    "Failed to initialize UHCI memory structures: %s.\n",
-	    str_error(ret));
+	if (ret != EOK) {
+		usb_log_error(
+		    "Failed to initialize UHCI memory structures: %s.\n",
+		    str_error(ret));
+		hcd_destroy(&instance->generic);
+		return ret;
+	}
 
 	hc_init_hw(instance);
@@ -146,5 +221,4 @@
 
 	return EOK;
-#undef CHECK_RET_DEST_FUN_RETURN
 }
 /*----------------------------------------------------------------------------*/
@@ -154,5 +228,5 @@
  * For magic values see UHCI Design Guide
  */
-void hc_init_hw(hc_t *instance)
+void hc_init_hw(const hc_t *instance)
 {
 	assert(instance);
@@ -198,5 +272,4 @@
  *
  * Structures:
- *  - interrupt code (I/O addressses are customized per instance)
  *  - transfer lists (queue heads need to be accessible by the hw)
  *  - frame list page (needs to be one UHCI hw accessible 4K page)
@@ -205,32 +278,21 @@
 {
 	assert(instance);
-#define CHECK_RET_RETURN(ret, message...) \
-	if (ret != EOK) { \
-		usb_log_error(message); \
-		return ret; \
-	} else (void) 0
+
+	/* Init USB frame list page */
+	instance->frame_list = get_page();
+	if (!instance->frame_list) {
+		return ENOMEM;
+	}
+	usb_log_debug("Initialized frame list at %p.\n", instance->frame_list);
 
 	/* Init transfer lists */
 	int ret = hc_init_transfer_lists(instance);
-	CHECK_RET_RETURN(ret, "Failed to initialize transfer lists.\n");
+	if (ret != EOK) {
+		usb_log_error("Failed to initialize transfer lists.\n");
+		return_page(instance->frame_list);
+		return ENOMEM;
+	}
 	usb_log_debug("Initialized transfer lists.\n");
 
-	/* Init device keeper */
-	usb_device_keeper_init(&instance->manager);
-	usb_log_debug("Initialized device keeper.\n");
-
-	ret = usb_endpoint_manager_init(&instance->ep_manager,
-	    BANDWIDTH_AVAILABLE_USB11);
-	CHECK_RET_RETURN(ret, "Failed to initialize endpoint manager: %s.\n",
-	    str_error(ret));
-
-	/* Init USB frame list page*/
-	instance->frame_list = get_page();
-	if (!instance->frame_list) {
-		usb_log_error("Failed to get frame list page.\n");
-		usb_endpoint_manager_destroy(&instance->ep_manager);
-		return ENOMEM;
-	}
-	usb_log_debug("Initialized frame list at %p.\n", instance->frame_list);
 
 	/* Set all frames to point to the first queue head */
@@ -243,5 +305,4 @@
 
 	return EOK;
-#undef CHECK_RET_RETURN
 }
 /*----------------------------------------------------------------------------*/
@@ -316,72 +377,22 @@
  * Checks for bandwidth availability and appends the batch to the proper queue.
  */
-int hc_schedule(hc_t *instance, usb_transfer_batch_t *batch)
-{
+int hc_schedule(hcd_t *hcd, usb_transfer_batch_t *batch)
+{
+	assert(hcd);
+	hc_t *instance = hcd->private_data;
 	assert(instance);
 	assert(batch);
+	uhci_transfer_batch_t *uhci_batch = uhci_transfer_batch_get(batch);
+	if (!uhci_batch) {
+		usb_log_error("Failed to create UHCI transfer structures.\n");
+		return ENOMEM;
+	}
 
 	transfer_list_t *list =
 	    instance->transfers[batch->ep->speed][batch->ep->transfer_type];
 	assert(list);
-	transfer_list_add_batch(list, batch);
-
-	return EOK;
-}
-/*----------------------------------------------------------------------------*/
-/** Take action based on the interrupt cause.
- *
- * @param[in] instance UHCI structure to use.
- * @param[in] status Value of the status register at the time of interrupt.
- *
- * Interrupt might indicate:
- * - transaction completed, either by triggering IOC, SPD, or an error
- * - some kind of device error
- * - resume from suspend state (not implemented)
- */
-void hc_interrupt(hc_t *instance, uint16_t status)
-{
-	assert(instance);
-	/* Lower 2 bits are transaction error and transaction complete */
-	if (status & (UHCI_STATUS_INTERRUPT | UHCI_STATUS_ERROR_INTERRUPT)) {
-		LIST_INITIALIZE(done);
-		transfer_list_remove_finished(
-		    &instance->transfers_interrupt, &done);
-		transfer_list_remove_finished(
-		    &instance->transfers_control_slow, &done);
-		transfer_list_remove_finished(
-		    &instance->transfers_control_full, &done);
-		transfer_list_remove_finished(
-		    &instance->transfers_bulk_full, &done);
-
-		while (!list_empty(&done)) {
-			link_t *item = list_first(&done);
-			list_remove(item);
-			usb_transfer_batch_t *batch =
-			    list_get_instance(item, usb_transfer_batch_t, link);
-			usb_transfer_batch_finish(batch);
-		}
-	}
-	/* Resume interrupts are not supported */
-	if (status & UHCI_STATUS_RESUME) {
-		usb_log_error("Resume interrupt!\n");
-	}
-
-	/* Bits 4 and 5 indicate hc error */
-	if (status & (UHCI_STATUS_PROCESS_ERROR | UHCI_STATUS_SYSTEM_ERROR)) {
-		usb_log_error("UHCI hardware failure!.\n");
-		++instance->hw_failures;
-		transfer_list_abort_all(&instance->transfers_interrupt);
-		transfer_list_abort_all(&instance->transfers_control_slow);
-		transfer_list_abort_all(&instance->transfers_control_full);
-		transfer_list_abort_all(&instance->transfers_bulk_full);
-
-		if (instance->hw_failures < UHCI_ALLOWED_HW_FAIL) {
-			/* reinitialize hw, this triggers virtual disconnect*/
-			hc_init_hw(instance);
-		} else {
-			usb_log_fatal("Too many UHCI hardware failures!.\n");
-			hc_fini(instance);
-		}
-	}
+	transfer_list_add_batch(list, uhci_batch);
+
+	return EOK;
 }
 /*----------------------------------------------------------------------------*/
@@ -403,8 +414,4 @@
 		if (status != 0)
 			usb_log_debug2("UHCI status: %x.\n", status);
-// Qemu fails to report stalled communication
-// see https://bugs.launchpad.net/qemu/+bug/757654
-// This is a simple workaround to force queue processing every time
-	//	status |= 1;
 		hc_interrupt(instance, status);
 		async_usleep(UHCI_INT_EMULATOR_TIMEOUT);
@@ -412,5 +419,5 @@
 	return EOK;
 }
-/*---------------------------------------------------------------------------*/
+/*----------------------------------------------------------------------------*/
 /** Debug function, checks consistency of memory structures.
  *
Index: uspace/drv/bus/usb/uhci/hc.h
===================================================================
--- uspace/drv/bus/usb/uhci/hc.h	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ uspace/drv/bus/usb/uhci/hc.h	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -39,7 +39,5 @@
 #include <ddi.h>
 
-#include <usb/host/device_keeper.h>
-#include <usb/host/usb_endpoint_manager.h>
-#include <usb/host/batch.h>
+#include <usb/host/hcd.h>
 
 #include "transfer_list.h"
@@ -94,8 +92,6 @@
 /** Main UHCI driver structure */
 typedef struct hc {
-	/** USB bus driver, devices and addresses */
-	usb_device_keeper_t manager;
-	/** USB bus driver, endpoints */
-	usb_endpoint_manager_t ep_manager;
+	/** Generic HCD driver structure */
+	hcd_t generic;
 
 	/** Addresses of I/O registers */
@@ -124,10 +120,10 @@
 	unsigned hw_failures;
 } hc_t;
+
 size_t hc_irq_cmd_count(void);
 int hc_get_irq_commands(
     irq_cmd_t cmds[], size_t cmd_size, uintptr_t regs, size_t reg_size);
+void hc_interrupt(hc_t *instance, uint16_t status);
 int hc_init(hc_t *instance, void *regs, size_t reg_size, bool interupts);
-int hc_schedule(hc_t *instance, usb_transfer_batch_t *batch);
-void hc_interrupt(hc_t *instance, uint16_t status);
 
 /** Safely dispose host controller internal structures
@@ -135,16 +131,5 @@
  * @param[in] instance Host controller structure to use.
  */
-static inline void hc_fini(hc_t *instance) { /* TODO: implement*/ };
-
-/** Get and cast pointer to the driver data
- *
- * @param[in] fun DDF function pointer
- * @return cast pointer to driver_data
- */
-static inline hc_t * fun_to_hc(ddf_fun_t *fun)
-{
-	assert(fun);
-	return fun->driver_data;
-}
+static inline void hc_fini(hc_t *instance) {} /* TODO: implement*/
 #endif
 /**
Index: uspace/drv/bus/usb/uhci/hw_struct/link_pointer.h
===================================================================
--- uspace/drv/bus/usb/uhci/hw_struct/link_pointer.h	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ uspace/drv/bus/usb/uhci/hw_struct/link_pointer.h	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -35,5 +35,5 @@
 #define DRV_UHCI_HW_STRUCT_LINK_POINTER_H
 
-/* UHCI link pointer, used by many data structures */
+/** UHCI link pointer, used by many data structures */
 typedef uint32_t link_pointer_t;
 
Index: uspace/drv/bus/usb/uhci/hw_struct/queue_head.h
===================================================================
--- uspace/drv/bus/usb/uhci/hw_struct/queue_head.h	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ uspace/drv/bus/usb/uhci/hw_struct/queue_head.h	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -58,6 +58,6 @@
 	assert(instance);
 
-	instance->element = 0 | LINK_POINTER_TERMINATE_FLAG;
-	instance->next = 0 | LINK_POINTER_TERMINATE_FLAG;
+	instance->element = LINK_POINTER_TERM;
+	instance->next = LINK_POINTER_TERM;
 }
 /*----------------------------------------------------------------------------*/
@@ -71,5 +71,8 @@
 static inline void qh_set_next_qh(qh_t *instance, qh_t *next)
 {
-	uint32_t pa = addr_to_phys(next);
+	/* Physical address has to be below 4GB,
+	 * it is an UHCI limitation and malloc32
+	 * should guarantee this */
+	const uint32_t pa = addr_to_phys(next);
 	if (pa) {
 		instance->next = LINK_POINTER_QH(pa);
@@ -88,5 +91,8 @@
 static inline void qh_set_element_td(qh_t *instance, td_t *td)
 {
-	uint32_t pa = addr_to_phys(td);
+	/* Physical address has to be below 4GB,
+	 * it is an UHCI limitation and malloc32
+	 * should guarantee this */
+	const uint32_t pa = addr_to_phys(td);
 	if (pa) {
 		instance->element = LINK_POINTER_TD(pa);
Index: uspace/drv/bus/usb/uhci/hw_struct/transfer_descriptor.c
===================================================================
--- uspace/drv/bus/usb/uhci/hw_struct/transfer_descriptor.c	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ uspace/drv/bus/usb/uhci/hw_struct/transfer_descriptor.c	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -61,6 +61,6 @@
  */
 void td_init(td_t *instance, int err_count, size_t size, bool toggle, bool iso,
-    bool low_speed, usb_target_t target, usb_packet_id pid, void *buffer,
-    td_t *next)
+    bool low_speed, usb_target_t target, usb_packet_id pid, const void *buffer,
+    const td_t *next)
 {
 	assert(instance);
@@ -113,5 +113,5 @@
  * @return Error code.
  */
-int td_status(td_t *instance)
+int td_status(const td_t *instance)
 {
 	assert(instance);
@@ -119,5 +119,5 @@
 	/* This is hc internal error it should never be reported. */
 	if ((instance->status & TD_STATUS_ERROR_BIT_STUFF) != 0)
-		return EAGAIN;
+		return EIO;
 
 	/* CRC or timeout error, like device not present or bad data,
@@ -150,5 +150,5 @@
  * @param[in] instance TD structure to use.
  */
-void td_print_status(td_t *instance)
+void td_print_status(const td_t *instance)
 {
 	assert(instance);
Index: uspace/drv/bus/usb/uhci/hw_struct/transfer_descriptor.h
===================================================================
--- uspace/drv/bus/usb/uhci/hw_struct/transfer_descriptor.h	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ uspace/drv/bus/usb/uhci/hw_struct/transfer_descriptor.h	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -69,5 +69,5 @@
 #define TD_STATUS_ACTLEN_MASK 0x7ff
 
-	/* double word with USB device specific info */
+	/** Double word with USB device specific info */
 	volatile uint32_t device;
 #define TD_DEVICE_MAXLEN_POS 21
@@ -87,6 +87,6 @@
 	/* According to UHCI design guide, there is 16 bytes of
 	 * data available here.
-	 * According to linux kernel the hardware does not care,
-	 * it just needs to be aligned. We don't use it anyway.
+	 * According to Linux kernel the hardware does not care,
+	 * memory just needs to be aligned. We don't use it anyway.
 	 */
 } __attribute__((packed)) td_t;
@@ -95,9 +95,9 @@
 void td_init(td_t *instance, int error_count, size_t size, bool toggle,
     bool iso, bool low_speed, usb_target_t target, usb_packet_id pid,
-    void *buffer, td_t *next);
+    const void *buffer, const td_t *next);
 
-int td_status(td_t *instance);
+int td_status(const td_t *instance);
 
-void td_print_status(td_t *instance);
+void td_print_status(const td_t *instance);
 /*----------------------------------------------------------------------------*/
 /** Helper function for parsing actual size out of TD.
@@ -106,8 +106,9 @@
  * @return Parsed actual size.
  */
-static inline size_t td_act_size(td_t *instance)
+static inline size_t td_act_size(const td_t *instance)
 {
 	assert(instance);
 	const uint32_t s = instance->status;
+	/* Actual size is encoded as n-1 (UHCI design guide p. 23) */
 	return ((s >> TD_STATUS_ACTLEN_POS) + 1) & TD_STATUS_ACTLEN_MASK;
 }
@@ -119,5 +120,5 @@
  * false otherwise.
  */
-static inline bool td_is_short(td_t *instance)
+static inline bool td_is_short(const td_t *instance)
 {
 	const size_t act_size = td_act_size(instance);
@@ -134,5 +135,5 @@
  * @return Toggle bit value.
  */
-static inline int td_toggle(td_t *instance)
+static inline int td_toggle(const td_t *instance)
 {
 	assert(instance);
@@ -145,5 +146,5 @@
  * @return Active bit value.
  */
-static inline bool td_is_active(td_t *instance)
+static inline bool td_is_active(const td_t *instance)
 {
 	assert(instance);
Index: uspace/drv/bus/usb/uhci/main.c
===================================================================
--- uspace/drv/bus/usb/uhci/main.c	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ uspace/drv/bus/usb/uhci/main.c	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -64,13 +64,14 @@
 	assert(device);
 
-	int ret = device_setup_uhci(device);
+	const int ret = device_setup_uhci(device);
 	if (ret != EOK) {
 		usb_log_error("Failed to initialize UHCI driver: %s.\n",
 		    str_error(ret));
-		return ret;
+	} else {
+		usb_log_info("Controlling new UHCI device '%s'.\n",
+		    device->name);
 	}
-	usb_log_info("Controlling new UHCI device '%s'.\n", device->name);
 
-	return EOK;
+	return ret;
 }
 /*----------------------------------------------------------------------------*/
Index: uspace/drv/bus/usb/uhci/pci.c
===================================================================
--- uspace/drv/bus/usb/uhci/pci.c	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ uspace/drv/bus/usb/uhci/pci.c	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -61,5 +61,5 @@
 	assert(io_reg_size);
 	assert(irq_no);
-	
+
 	async_sess_t *parent_sess =
 	    devman_parent_device_connect(EXCHANGE_SERIALIZE, dev->handle,
@@ -67,19 +67,19 @@
 	if (!parent_sess)
 		return ENOMEM;
-	
+
 	hw_resource_list_t hw_resources;
-	int rc = hw_res_get_resource_list(parent_sess, &hw_resources);
+	const int rc = hw_res_get_resource_list(parent_sess, &hw_resources);
+	async_hangup(parent_sess);
 	if (rc != EOK) {
-		async_hangup(parent_sess);
 		return rc;
 	}
-	
+
 	uintptr_t io_address = 0;
 	size_t io_size = 0;
 	bool io_found = false;
-	
+
 	int irq = 0;
 	bool irq_found = false;
-	
+
 	size_t i;
 	for (i = 0; i < hw_resources.count; i++) {
@@ -102,17 +102,16 @@
 		}
 	}
-	
-	async_hangup(parent_sess);
-	
+	free(hw_resources.resources);
+
 	if (!io_found || !irq_found)
 		return ENOENT;
-	
+
 	*io_reg_address = io_address;
 	*io_reg_size = io_size;
 	*irq_no = irq;
-	
+
 	return EOK;
 }
-
+/*----------------------------------------------------------------------------*/
 /** Call the PCI driver with a request to enable interrupts
  *
@@ -127,11 +126,11 @@
 	if (!parent_sess)
 		return ENOMEM;
-	
+
 	const bool enabled = hw_res_enable_interrupt(parent_sess);
 	async_hangup(parent_sess);
-	
+
 	return enabled ? EOK : EIO;
 }
-
+/*----------------------------------------------------------------------------*/
 /** Call the PCI driver with a request to clear legacy support register
  *
@@ -142,5 +141,5 @@
 {
 	assert(device);
-	
+
 	async_sess_t *parent_sess =
 	    devman_parent_device_connect(EXCHANGE_SERIALIZE, device->handle,
@@ -148,18 +147,18 @@
 	if (!parent_sess)
 		return ENOMEM;
-	
+
 	/* See UHCI design guide for these values p.45,
 	 * write all WC bits in USB legacy register */
 	const sysarg_t address = 0xc0;
 	const sysarg_t value = 0xaf00;
-	
+
 	async_exch_t *exch = async_exchange_begin(parent_sess);
-	
+
 	const int rc = async_req_3_0(exch, DEV_IFACE_ID(PCI_DEV_IFACE),
 	    IPC_M_CONFIG_SPACE_WRITE_16, address, value);
-	
+
 	async_exchange_end(exch);
 	async_hangup(parent_sess);
-	
+
 	return rc;
 }
Index: uspace/drv/bus/usb/uhci/root_hub.c
===================================================================
--- uspace/drv/bus/usb/uhci/root_hub.c	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ uspace/drv/bus/usb/uhci/root_hub.c	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -50,14 +50,6 @@
 int rh_init(rh_t *instance, ddf_fun_t *fun, uintptr_t reg_addr, size_t reg_size)
 {
-	int ret;
-
+	assert(instance);
 	assert(fun);
-
-	ret = ddf_fun_add_match_id(fun, "usb&uhci&root-hub", 100);
-	if (ret != EOK) {
-		usb_log_error("Failed to add root hub match id: %s\n",
-		    str_error(ret));
-		return ret;
-	}
 
 	/* Initialize resource structure */
@@ -70,5 +62,10 @@
 	instance->io_regs.res.io_range.endianness = LITTLE_ENDIAN;
 
-	return EOK;
+	const int ret = ddf_fun_add_match_id(fun, "usb&uhci&root-hub", 100);
+	if (ret != EOK) {
+		usb_log_error("Failed to add root hub match id: %s\n",
+		    str_error(ret));
+	}
+	return ret;
 }
 /**
Index: uspace/drv/bus/usb/uhci/transfer_list.c
===================================================================
--- uspace/drv/bus/usb/uhci/transfer_list.c	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ uspace/drv/bus/usb/uhci/transfer_list.c	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -37,9 +37,9 @@
 #include <usb/debug.h>
 #include <libarch/barrier.h>
+
 #include "transfer_list.h"
-#include "batch.h"
 
 static void transfer_list_remove_batch(
-    transfer_list_t *instance, usb_transfer_batch_t *batch);
+    transfer_list_t *instance, uhci_transfer_batch_t *uhci_batch);
 /*----------------------------------------------------------------------------*/
 /** Initialize transfer list structures.
@@ -106,24 +106,22 @@
  */
 void transfer_list_add_batch(
-    transfer_list_t *instance, usb_transfer_batch_t *batch)
-{
-	assert(instance);
-	assert(batch);
-	usb_log_debug2("Queue %s: Adding batch(%p).\n", instance->name, batch);
+    transfer_list_t *instance, uhci_transfer_batch_t *uhci_batch)
+{
+	assert(instance);
+	assert(uhci_batch);
+	usb_log_debug2("Queue %s: Adding batch(%p).\n", instance->name,
+	    uhci_batch->usb_batch);
 
 	fibril_mutex_lock(&instance->guard);
 
-	qh_t *last_qh = NULL;
+	/* Assume there is nothing scheduled */
+	qh_t *last_qh = instance->queue_head;
+	/* There is something scheduled */
+	if (!list_empty(&instance->batch_list)) {
+		last_qh = uhci_transfer_batch_from_link(
+		    list_last(&instance->batch_list))->qh;
+	}
 	/* Add to the hardware queue. */
-	if (list_empty(&instance->batch_list)) {
-		/* There is nothing scheduled */
-		last_qh = instance->queue_head;
-	} else {
-		/* There is something scheduled */
-		usb_transfer_batch_t *last = usb_transfer_batch_from_link(
-		    list_last(&instance->batch_list));
-		last_qh = batch_qh(last);
-	}
-	const uint32_t pa = addr_to_phys(batch_qh(batch));
+	const uint32_t pa = addr_to_phys(uhci_batch->qh);
 	assert((pa & LINK_POINTER_ADDRESS_MASK) == pa);
 
@@ -132,6 +130,6 @@
 
 	/* keep link */
-	batch_qh(batch)->next = last_qh->next;
-	qh_set_next_qh(last_qh, batch_qh(batch));
+	uhci_batch->qh->next = last_qh->next;
+	qh_set_next_qh(last_qh, uhci_batch->qh);
 
 	/* Make sure the pointer is updated */
@@ -139,8 +137,9 @@
 
 	/* Add to the driver's list */
-	list_append(&batch->link, &instance->batch_list);
+	list_append(&uhci_batch->link, &instance->batch_list);
 
 	usb_log_debug2("Batch %p " USB_TRANSFER_BATCH_FMT " scheduled in queue %s.\n",
-	    batch, USB_TRANSFER_BATCH_ARGS(*batch), instance->name);
+	    uhci_batch, USB_TRANSFER_BATCH_ARGS(*uhci_batch->usb_batch),
+	    instance->name);
 	fibril_mutex_unlock(&instance->guard);
 }
@@ -157,11 +156,11 @@
 
 	fibril_mutex_lock(&instance->guard);
-	link_t *current = instance->batch_list.head.next;
-	while (current != &instance->batch_list.head) {
+	link_t *current = list_first(&instance->batch_list);
+	while (current && current != &instance->batch_list.head) {
 		link_t * const next = current->next;
-		usb_transfer_batch_t *batch =
-		    usb_transfer_batch_from_link(current);
-
-		if (batch_is_complete(batch)) {
+		uhci_transfer_batch_t *batch =
+		    uhci_transfer_batch_from_link(current);
+
+		if (uhci_transfer_batch_is_complete(batch)) {
 			/* Save for processing */
 			transfer_list_remove_batch(instance, batch);
@@ -182,8 +181,9 @@
 	while (!list_empty(&instance->batch_list)) {
 		link_t * const current = list_first(&instance->batch_list);
-		usb_transfer_batch_t *batch =
-		    usb_transfer_batch_from_link(current);
+		uhci_transfer_batch_t *batch =
+		    uhci_transfer_batch_from_link(current);
 		transfer_list_remove_batch(instance, batch);
-		usb_transfer_batch_finish_error(batch, EINTR);
+		batch->usb_batch->error = EINTR;
+		uhci_transfer_batch_call_dispose(batch);
 	}
 	fibril_mutex_unlock(&instance->guard);
@@ -198,32 +198,28 @@
  */
 void transfer_list_remove_batch(
-    transfer_list_t *instance, usb_transfer_batch_t *batch)
+    transfer_list_t *instance, uhci_transfer_batch_t *uhci_batch)
 {
 	assert(instance);
 	assert(instance->queue_head);
-	assert(batch);
-	assert(batch_qh(batch));
+	assert(uhci_batch);
+	assert(uhci_batch->qh);
 	assert(fibril_mutex_is_locked(&instance->guard));
 
-	usb_log_debug2(
-	    "Queue %s: removing batch(%p).\n", instance->name, batch);
-
-	const char *qpos = NULL;
-	qh_t *prev_qh = NULL;
+	usb_log_debug2("Queue %s: removing batch(%p).\n",
+	    instance->name, uhci_batch->usb_batch);
+
+	/* Assume I'm the first */
+	const char *qpos = "FIRST";
+	qh_t *prev_qh = instance->queue_head;
 	/* Remove from the hardware queue */
-	if (list_first(&instance->batch_list) == &batch->link) {
-		/* I'm the first one here */
-		prev_qh = instance->queue_head;
-		qpos = "FIRST";
-	} else {
-		/* The thing before me is a batch too */
-		usb_transfer_batch_t *prev =
-		    usb_transfer_batch_from_link(batch->link.prev);
-		prev_qh = batch_qh(prev);
+	if (list_first(&instance->batch_list) != &uhci_batch->link) {
+		/* There is a batch in front of me */
+		prev_qh =
+		    uhci_transfer_batch_from_link(uhci_batch->link.prev)->qh;
 		qpos = "NOT FIRST";
 	}
 	assert((prev_qh->next & LINK_POINTER_ADDRESS_MASK)
-	    == addr_to_phys(batch_qh(batch)));
-	prev_qh->next = batch_qh(batch)->next;
+	    == addr_to_phys(uhci_batch->qh));
+	prev_qh->next = uhci_batch->qh->next;
 
 	/* Make sure the pointer is updated */
@@ -231,9 +227,9 @@
 
 	/* Remove from the batch list */
-	list_remove(&batch->link);
+	list_remove(&uhci_batch->link);
 	usb_log_debug2("Batch %p " USB_TRANSFER_BATCH_FMT " removed (%s) "
 	    "from %s, next: %x.\n",
-	    batch, USB_TRANSFER_BATCH_ARGS(*batch),
-	    qpos, instance->name, batch_qh(batch)->next);
+	    uhci_batch, USB_TRANSFER_BATCH_ARGS(*uhci_batch->usb_batch),
+	    qpos, instance->name, uhci_batch->qh->next);
 }
 /**
